## sarg 2.2.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 PROJECT(sarg C)
 SET(sarg_VERSION 2)
 SET(sarg_REVISION 2)
-SET(sarg_BUILD "6")
-SET(sarg_BUILDDATE "Nov-30-2009")
+SET(sarg_BUILD "7.1")
+SET(sarg_BUILDDATE "Feb-12-2010")
 
 INCLUDE(AddFileDependencies)
 INCLUDE(CheckIncludeFile)
@@ -11,6 +11,7 @@
 INCLUDE(CheckFunctionExists)
 INCLUDE(CheckTypeSize)
 INCLUDE(CheckSymbolExists)
+INCLUDE(CheckCCompilerFlag)
 
 DEFINE_PROPERTY(GLOBAL PROPERTY enable-htmldir BRIEF_DOCS "--enable-htmldir=htmldir"
                         FULL_DOCS "Select htmldir as the root of your WWW documents")
@@ -40,6 +41,7 @@
 SET(LANGDIR "share/sarg/languages" CACHE PATH "The directory to copy the languages files relative to the install directory")
 SET(FONTDIR "share/sarg/fonts" CACHE PATH "The directory to copy the fonts relative to the install directory")
 SET(IMAGEDIR "share/sarg/images" CACHE PATH "The directory to copy the images files relative to the install directory")
+SET(SARGPHPDIR "share/sarg/sarg-php" CACHE PATH "The directory to copy sarg-php relative to the install directory")
 
 # Sources to compile
 INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}") #Make it find this config.h before the one in src/include
@@ -58,8 +60,22 @@
 
 ADD_EXECUTABLE(sarg ${SRC})
 
-SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAG "${CFLAGS} -Wall -Wextra -Werror=implicit-function-declaration -Werror=format")
 SET_TARGET_PROPERTIES(sarg PROPERTIES VERSION "${sarg_VERSION}.${sarg_REVISION}.${sarg_BUILD}")
+
+SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "$ENV{CFLAGS} -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter")
+SET_TARGET_PROPERTIES(sarg PROPERTIES LINK_FLAGS "$ENV{LDFLAGS}")
+
+CHECK_C_COMPILER_FLAG("-Werror=implicit-function-declaration" HAVE_WERROR_IMPLICIT_FUNCTION)
+IF(HAVE_WERROR_IMPLICIT_FUNCTION)
+   GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
+   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -Werror=implicit-function-declaration")
+ENDIF(HAVE_WERROR_IMPLICIT_FUNCTION)
+
+CHECK_C_COMPILER_FLAG("-Werror=format" HAVE_WERROR_FORMAT)
+IF(HAVE_WERROR_FORMAT)
+   GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
+   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -Werror=format")
+ENDIF(HAVE_WERROR_FORMAT)
 
 # Required header files
 CHECK_INCLUDE_FILE(stdio.h HAVE_STDIO_H)
@@ -84,8 +100,13 @@
 CHECK_INCLUDE_FILE(stdarg.h HAVE_STDARG_H)
 CHECK_INCLUDE_FILE(inttypes.h HAVE_INTTYPES_H)
 CHECK_INCLUDE_FILE(limits.h HAVE_LIMITS_H)
+CHECK_INCLUDE_FILE(locale.h HAVE_LOCALE_H)
+CHECK_INCLUDE_FILE(execinfo.h HAVE_EXECINFO_H)
 
 CHECK_FUNCTION_EXISTS(bzero HAVE_BZERO)
+CHECK_FUNCTION_EXISTS(backtrace HAVE_BACKTRACE)
+CHECK_FUNCTION_EXISTS(symlink HAVE_SYMLINK)
+CHECK_FUNCTION_EXISTS(lstat HAVE_LSTAT)
 
 # Find gd
 CHECK_INCLUDE_FILE(gd.h HAVE_GD_H)
@@ -95,10 +116,10 @@
    CHECK_INCLUDE_FILE(gdfonts.h HAVE_GDFONTS_H)
    CHECK_INCLUDE_FILE(gdfontmb.h HAVE_GDFONTMB_H)
    CHECK_INCLUDE_FILE(gdfontg.h HAVE_GDFONTG_H)
-   FIND_LIBRARY(GD_LIBRARY NAMES gd DOC "The GD library")
+   FIND_LIBRARY(GD_LIBRARY NAMES gd bgd DOC "The GD library")
    IF(GD_LIBRARY)
       #CHECK_LIBRARY_EXISTS(gd gdImagePng "." HAVE_GD)
-      TARGET_LINK_LIBRARIES(sarg gd)
+      TARGET_LINK_LIBRARIES(sarg ${GD_LIBRARY})
       SET(HAVE_GD GD_LIBRARY CACHE PATH DOC "True IF GD was found")
       SET(HAVE_GD CACHE BOOL DOC "True IF must use GD")
    ENDIF(GD_LIBRARY)
@@ -109,11 +130,12 @@
 IF(ENABLE_ICONV)
    CHECK_INCLUDE_FILE(iconv.h HAVE_ICONV_H)
    IF(HAVE_ICONV_H)
+      FIND_PATH(ICONV_INCLUDE_PATH NAMES iconv.h)
+      FIND_LIBRARY(ICONV_LIBRARY NAMES iconv DOC "The ICONV library")
+      IF(ICONV_LIBRARY)
+         TARGET_LINK_LIBRARIES(sarg ${ICONV_LIBRARY})
+      ENDIF(ICONV_LIBRARY)
       CHECK_FUNCTION_EXISTS(iconv_open HAVE_ICONV)
-      IF(!HAVE_ICONV)
-         FIND_PATH(ICONV_INCLUDE_PATH NAMES iconv.h)
-         FIND_LIBRARY(ICONV_LIBRARY NAMES iconv DOC "The ICONV library")
-      ENDIF(!HAVE_ICONV)
 
       SET(ICONV_CONST_FILE ${CMAKE_BINARY_DIR}/consticonv.c)
       FILE(WRITE ${ICONV_CONST_FILE} "
@@ -187,18 +209,6 @@
    ADD_DEFINITIONS(-D_LARGEFILE64_SOURCE)
 ENDIF(LFS_NEED_DEFINE)
 
-# Find off_t size
-CHECK_TYPE_SIZE(off_t OFF_T)
-IF(HAVE_OFF_T)
-   IF(OFF_T STREQUAL 4)
-      SET(OFFSET_STRING "\"%d\"")
-   elseif(OFF_T STREQUAL 8)
-      SET(OFFSET_STRING "\"%\"PRId64")
-   ENDIF(OFF_T STREQUAL 4)
-ELSE(HAVE_OFF_T)
-   MESSAGE(FATAL_ERROR Need off_t to compile the program)
-ENDIF(HAVE_OFF_T)
-
 # Find rlim_t
 IF(HAVE_SYS_RESOURCE_H)
    SET(CMAKE_EXTRA_INCLUDE_FILES "sys/resource.h")
@@ -247,7 +257,13 @@
 
 OPTION(ENABLE_EXTRA_PROTECT "Enable compile and runtime extra protections" OFF)
 IF(ENABLE_EXTRA_PROTECT)
-   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAG "${CFLAGS} -Werror=format-security -fstack-protector -D_FORTIFY_SOURCE=2 -Werror -Wextra -Wno-sign-compare -Wno-unused-parameter")
+   GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
+   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -fstack-protector -D_FORTIFY_SOURCE=2 -Werror")
+   CHECK_C_COMPILER_FLAG("-Wformat -Werror=format-security" HAVE_WERROR_FORMAT_SECURITY)
+   IF(HAVE_WERROR_FORMAT_SECURITY)
+      GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
+      SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -Wformat -Werror=format-security")
+   ENDIF(HAVE_WERROR_FORMAT_SECURITY)
 ENDIF(ENABLE_EXTRA_PROTECT)
 
 # Save the configuration for the project
@@ -258,9 +274,10 @@
 INSTALL(FILES sarg.conf DESTINATION "${SYSCONFDIR}" RENAME sarg.conf.exemple)
 INSTALL(FILES exclude_codes user_limit_block css.tpl DESTINATION "${SYSCONFDIR}")
 INSTALL(FILES sarg.1 DESTINATION "${MANDIR}")
-INSTALL(DIRECTORY languages/ DESTINATION "${LANGDIR}" PATTERN "CVS" EXCLUDE)
-INSTALL(DIRECTORY images/ DESTINATION "${IMAGEDIR}" PATTERN "CVS" EXCLUDE)
-INSTALL(DIRECTORY fonts/ DESTINATION "${FONTDIR}" FILES_MATCHING PATTERN "*.ttf" PATTERN "CVS" EXCLUDE)
+INSTALL(DIRECTORY languages/ DESTINATION "${LANGDIR}" PATTERN ".svn" EXCLUDE)
+INSTALL(DIRECTORY images/ DESTINATION "${IMAGEDIR}" PATTERN ".svn" EXCLUDE)
+INSTALL(DIRECTORY fonts/ DESTINATION "${FONTDIR}" FILES_MATCHING PATTERN "*.ttf" PATTERN ".svn" EXCLUDE)
+INSTALL(DIRECTORY sarg-php/ DESTINATION "${SARGPHPDIR}" PATTERN ".svn" EXCLUDE)
 
 # Package creation
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Squid Analysis Report Generator")
@@ -269,5 +286,5 @@
 SET(CPACK_PACKAGE_VERSION_PATCH "${sarg_BUILD}")
 SET(CPACK_GENERATOR TGZ)
 SET(CPACK_SOURCE_GENERATOR TGZ)
-SET(CPACK_SOURCE_IGNORE_FILES "/CVS/" "/debian/" "/html/" "Makefile$" "config\\\\.log$" "config\\\\.status$" ".*~$" "\\\\.o$")
+SET(CPACK_SOURCE_IGNORE_FILES "/.svn/" "/debian/" "/html/" "Makefile$" "config\\\\.log$" "config\\\\.status$" ".*~$" "\\\\.o$")
 INCLUDE(CPack)
