## sarg 2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
 PROJECT(sarg C)
 SET(sarg_VERSION 2)
-SET(sarg_REVISION 2)
-SET(sarg_BUILD "7.1")
-SET(sarg_BUILDDATE "Feb-12-2010")
+SET(sarg_REVISION "3")
+SET(sarg_BUILD "")
+SET(sarg_BUILDDATE "Jun-21-2010")
 
 INCLUDE(AddFileDependencies)
 INCLUDE(CheckIncludeFile)
@@ -17,7 +17,7 @@
                         FULL_DOCS "Select htmldir as the root of your WWW documents")
 
 SET(PACKAGE_NAME "sarg")
-SET(PACKAGE_VERSION "${sarg_VERSION}.${sarg_REVISION}.${sarg_BUILD}")
+SET(PACKAGE_VERSION "${sarg_VERSION}.${sarg_REVISION}${sarg_BUILD}")
 
 MACRO(SET_ABS_SOURCE VAR DOC)
    IF(${VAR} AND NOT ${VAR}_SOURCE)
@@ -50,9 +50,10 @@
        totger.c index.c getconf.c usage.c decomp.c ip2name.c
        useragent.c exclude.c convlog.c totday.c repday.c datafile.c
        indexonly.c splitlog.c lastlog.c topsites.c siteuser.c css.c
-       smartfilter.c denied.c authfail.c language.c charset.c
+       smartfilter.c denied.c authfail.c charset.c
        squidguard_log.c squidguard_report.c auth.c download.c grepday.c
-       dansguardian_log.c dansguardian_report.c realtime.c)
+       dansguardian_log.c dansguardian_report.c realtime.c btree_cache.c
+       usertab.c userinfo.c longline.c)
 
 FOREACH(f ${SRC})
    ADD_FILE_DEPENDENCIES(${f} ${CMAKE_BINARY_DIR}/config.h ${CMAKE_SOURCE_DIR}/include/conf.h ${CMAKE_SOURCE_DIR}/include/info.h ${CMAKE_SOURCE_DIR}/include/defs.h)
@@ -62,8 +63,15 @@
 
 SET_TARGET_PROPERTIES(sarg PROPERTIES VERSION "${sarg_VERSION}.${sarg_REVISION}.${sarg_BUILD}")
 
-SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "$ENV{CFLAGS} -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter")
+SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "$ENV{CFLAGS} -Wall -Wno-sign-compare")
 SET_TARGET_PROPERTIES(sarg PROPERTIES LINK_FLAGS "$ENV{LDFLAGS}")
+
+CHECK_C_COMPILER_FLAG("-Wextra" HAVE_WEXTRA)
+IF(HAVE_WEXTRA)
+   # Not supported by gcc 3.3
+   GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
+   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -Wextra -Wno-unused-parameter")
+ENDIF(HAVE_WEXTRA)
 
 CHECK_C_COMPILER_FLAG("-Werror=implicit-function-declaration" HAVE_WERROR_IMPLICIT_FUNCTION)
 IF(HAVE_WERROR_IMPLICIT_FUNCTION)
@@ -100,13 +108,45 @@
 CHECK_INCLUDE_FILE(stdarg.h HAVE_STDARG_H)
 CHECK_INCLUDE_FILE(inttypes.h HAVE_INTTYPES_H)
 CHECK_INCLUDE_FILE(limits.h HAVE_LIMITS_H)
+CHECK_INCLUDE_FILE(math.h HAVE_MATH_H)
 CHECK_INCLUDE_FILE(locale.h HAVE_LOCALE_H)
 CHECK_INCLUDE_FILE(execinfo.h HAVE_EXECINFO_H)
+CHECK_INCLUDE_FILE(libintl.h HAVE_LIBINTL_H)
+CHECK_INCLUDE_FILE(libgen.h HAVE_LIBGEN_H)
+CHECK_INCLUDE_FILE(stdbool.h HAVE_STDBOOL_H)
+CHECK_INCLUDE_FILE(getopt.h HAVE_GETOPT_H)
+
+IF(!HAVE_GETOPT_H)
+   MESSAGE(SEND_ERROR "getopt.h is required to compile sarg")
+ENDIF(!HAVE_GETOPT_H)
+
+# Windows need lib wsock32 and ws2_32
+IF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
+   CHECK_INCLUDE_FILE(windows.h HAVE_WINDOWS_H)
+   CHECK_INCLUDE_FILE(winsock.h HAVE_WINSOCK_H)
+   CHECK_INCLUDE_FILE(ws2tcpip.h HAVE_WS2TCPIP_H)
+
+   FIND_LIBRARY(WSOCK_LIB NAMES wsock32 DOC "The winsock library")
+   IF(WSOCK_LIB)
+      TARGET_LINK_LIBRARIES(sarg wsock32)
+      LIST(APPEND CMAKE_REQUIRED_LIBRARIES wsock32)
+   ENDIF(WSOCK_LIB)
+
+   FIND_LIBRARY(WSOCK2_LIB NAMES ws2_32 DOC "The winsock 2 library")
+   IF(WSOCK2_LIB)
+      TARGET_LINK_LIBRARIES(sarg ws2_32)
+      LIST(APPEND CMAKE_REQUIRED_LIBRARIES ws2_32)
+   ENDIF(WSOCK2_LIB)
+
+   ADD_DEFINITIONS(-DWINDOWS)
+ENDIF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
 
 CHECK_FUNCTION_EXISTS(bzero HAVE_BZERO)
 CHECK_FUNCTION_EXISTS(backtrace HAVE_BACKTRACE)
 CHECK_FUNCTION_EXISTS(symlink HAVE_SYMLINK)
 CHECK_FUNCTION_EXISTS(lstat HAVE_LSTAT)
+CHECK_FUNCTION_EXISTS(getnameinfo HAVE_GETNAMEINFO)
+CHECK_FUNCTION_EXISTS(inet_aton HAVE_INET_ATON)
 
 # Find gd
 CHECK_INCLUDE_FILE(gd.h HAVE_GD_H)
@@ -118,10 +158,10 @@
    CHECK_INCLUDE_FILE(gdfontg.h HAVE_GDFONTG_H)
    FIND_LIBRARY(GD_LIBRARY NAMES gd bgd DOC "The GD library")
    IF(GD_LIBRARY)
-      #CHECK_LIBRARY_EXISTS(gd gdImagePng "." HAVE_GD)
+      #CHECK_LIBRARY_EXISTS(gd gdImagePng "." HAVE_GD_LIB)
       TARGET_LINK_LIBRARIES(sarg ${GD_LIBRARY})
-      SET(HAVE_GD GD_LIBRARY CACHE PATH DOC "True IF GD was found")
-      SET(HAVE_GD CACHE BOOL DOC "True IF must use GD")
+      SET(HAVE_GD_LIB GD_LIBRARY CACHE PATH DOC "True IF GD was found")
+      SET(HAVE_GD_LIB CACHE BOOL DOC "True IF must use GD")
    ENDIF(GD_LIBRARY)
 ENDIF(HAVE_GD_H)
 
@@ -137,27 +177,54 @@
       ENDIF(ICONV_LIBRARY)
       CHECK_FUNCTION_EXISTS(iconv_open HAVE_ICONV)
 
-      SET(ICONV_CONST_FILE ${CMAKE_BINARY_DIR}/consticonv.c)
-      FILE(WRITE ${ICONV_CONST_FILE} "
-#include <stdlib.h>
+      IF(NOT USE_CONST_ICONV)
+         SET(ICONV_CONST_FILE ${CMAKE_BINARY_DIR}/consticonv.c)
+         FILE(WRITE ${ICONV_CONST_FILE} "
 #include <iconv.h>
-extern
-#ifdef __cplusplus
-"C"
+#ifdef __CLASSIC_C__
+int main(){
+  int ac;
+  char*av[];
+#else
+int main(int ac, char*av[]){
 #endif
-#if defined(__STDC__) || defined(__cplusplus)
-size_t iconv (iconv_t cd, char * *inbuf, size_t *inbytesleft, char * *outbuf, size_t *outbytesleft);
-#else
-size_t iconv();
-#endif
+  iconv_t localtoutf=(iconv_t)-1;
+  const char *str=\"\";
+  char *sstr=\"\";
+  size_t slen=0, sslen=0;
+
+  iconv (localtoutf, (const char **)&str, &slen, &sstr, &sslen);
+  if(ac > 1000)
+    {
+    return *av[0];
+    }
+  return 0;
+}
 ")
-      TRY_COMPILE(USE_CONST_ICONV ${CMAKE_BINARY_DIR} ${ICONV_CONST_FILE})
-      FILE(REMOVE ${ICONV_CONST_FILE})
-      IF(USE_CONST_ICONV)
-         SET(ICONV_CONST "\"const\"")
-      ENDIF(USE_CONST_ICONV)
+         TRY_COMPILE(USE_CONST_ICONV ${CMAKE_BINARY_DIR} ${ICONV_CONST_FILE} CMAKE_FLAGS -DLINK_LIBRARIES="iconv")
+         FILE(REMOVE ${ICONV_CONST_FILE})
+         IF(USE_CONST_ICONV)
+            SET(ICONV_CONST "const" CACHE STRING "The type of char to use with iconv")
+            MESSAGE(STATUS "iconv requires const char **")
+         ELSEIF(USE_CONST_ICONV)
+            SET(ICONV_CONST "" CACHE STRING "The type of char to use with iconv")
+            MESSAGE(STATUS "iconv requires char **")
+         ENDIF(USE_CONST_ICONV)
+         SET(USE_CONST_ICONV TRUE CACHE BOOL "Use const char ** with iconv")
+      ENDIF(NOT USE_CONST_ICONV)
    ENDIF(HAVE_ICONV_H)
 ENDIF(ENABLE_ICONV)
+
+# Find ldap
+CHECK_INCLUDE_FILE(ldap.h HAVE_LDAP_H)
+IF(HAVE_LDAP_H)
+   FIND_LIBRARY(LDAP_LIBRARY NAMES ldap DOC "The ldap library")
+   IF(LDAP_LIBRARY)
+      TARGET_LINK_LIBRARIES(sarg ${LDAP_LIBRARY})
+      SET(HAVE_LDAP LDAP_LIBRARY CACHE PATH DOC "True if LDAP was found")
+      SET(HAVE_LDAP CACHE BOOL DOC "True if must use LDAP")
+   ENDIF(LDAP_LIBRARY)
+ENDIF(HAVE_LDAP_H)
 
 # Support for large files
 OPTION(ENABLE_LARGEFILE "Enable the usage of large files" ON)
@@ -222,22 +289,9 @@
    ELSE(RLIM_T STREQUAL 4)
       MESSAGE("Unknown rlim_t size")
    ENDIF(RLIM_T STREQUAL 4)
-ELSE(HAVE_RLIM_T)
-   MESSAGE("Cannot detect the size of your system's rlim_t type")
+#ELSE(HAVE_RLIM_T)
+#   MESSAGE("Cannot detect the size of your system's rlim_t type")
 ENDIF(HAVE_RLIM_T)
-
-# Windows need lib wsock32
-IF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
-   CHECK_INCLUDE_FILE(windows.h HAVE_WINDOWS_H)
-   CHECK_INCLUDE_FILE(winsock.h HAVE_WINSOCK_H)
-   FIND_LIBRARY(WSOCK_LIB NAMES wsock32 DOC "The winsock library")
-   #check_library_exists(wsock32 "." HAVE_WSOCK)
-   IF(WSOCK_LIB)
-      #set_target_properties(sarg PROPERTIES LINK_FLAGS "${LINK_FLAGS} -lwsock32")
-      TARGET_LINK_LIBRARIES(sarg wsock32)
-   ENDIF(WSOCK_LIB)
-   ADD_DEFINITIONS(-DWINDOWS)
-ENDIF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
 
 CHECK_FUNCTION_EXISTS(mkstemp HAVE_MKSTEMP)
 IF(NOT HAVE_MKSTEMP)
@@ -248,43 +302,14 @@
    ENDIF(IBERTY_LIB)
 ENDIF(NOT HAVE_MKSTEMP)
 
-# System particularities
-IF(CMAKE_SYSTEM_NAME STREQUAL "solaris")
-   TARGET_LINK_LIBRARIES(sarg socket nsl)
-   #SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_DEFINITIONS="-DSOLARIS ${COMPILE_DEFINITIONS}")
-   ADD_DEFINITIONS(-DSOLARIS)
-ENDIF(CMAKE_SYSTEM_NAME STREQUAL "solaris")
-
-OPTION(ENABLE_EXTRA_PROTECT "Enable compile and runtime extra protections" OFF)
-IF(ENABLE_EXTRA_PROTECT)
-   GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
-   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -fstack-protector -D_FORTIFY_SOURCE=2 -Werror")
-   CHECK_C_COMPILER_FLAG("-Wformat -Werror=format-security" HAVE_WERROR_FORMAT_SECURITY)
-   IF(HAVE_WERROR_FORMAT_SECURITY)
-      GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
-      SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -Wformat -Werror=format-security")
-   ENDIF(HAVE_WERROR_FORMAT_SECURITY)
-ENDIF(ENABLE_EXTRA_PROTECT)
-
-# Save the configuration for the project
-CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/config.h.in" "${CMAKE_BINARY_DIR}/config.h" @ONLY)
-
-# Installation of the project
-INSTALL(TARGETS sarg DESTINATION "${BINDIR}")
-INSTALL(FILES sarg.conf DESTINATION "${SYSCONFDIR}" RENAME sarg.conf.exemple)
-INSTALL(FILES exclude_codes user_limit_block css.tpl DESTINATION "${SYSCONFDIR}")
-INSTALL(FILES sarg.1 DESTINATION "${MANDIR}")
-INSTALL(DIRECTORY languages/ DESTINATION "${LANGDIR}" PATTERN ".svn" EXCLUDE)
-INSTALL(DIRECTORY images/ DESTINATION "${IMAGEDIR}" PATTERN ".svn" EXCLUDE)
-INSTALL(DIRECTORY fonts/ DESTINATION "${FONTDIR}" FILES_MATCHING PATTERN "*.ttf" PATTERN ".svn" EXCLUDE)
-INSTALL(DIRECTORY sarg-php/ DESTINATION "${SARGPHPDIR}" PATTERN ".svn" EXCLUDE)
-
-# Package creation
-SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Squid Analysis Report Generator")
-SET(CPACK_PACKAGE_VERSION_MAJOR "${sarg_VERSION}")
-SET(CPACK_PACKAGE_VERSION_MINOR "${sarg_REVISION}")
-SET(CPACK_PACKAGE_VERSION_PATCH "${sarg_BUILD}")
-SET(CPACK_GENERATOR TGZ)
-SET(CPACK_SOURCE_GENERATOR TGZ)
-SET(CPACK_SOURCE_IGNORE_FILES "/.svn/" "/debian/" "/html/" "Makefile$" "config\\\\.log$" "config\\\\.status$" ".*~$" "\\\\.o$")
-INCLUDE(CPack)
+# Gettext and friends
+IF(NOT HAVE_LC_MESSAGES)
+   SET(FILES)
+   IF(HAVE_LOCALE_H)
+      LIST(APPEND FILES "locale.h")
+   ENDIF(HAVE_LOCALE_H)
+   IF(HAVE_LIBINTL_H)
+      LIST(APPEND FILES "libintl.h")
+   ENDIF(HAVE_LIBINTL_H)
+   LIST(LENGTH FILES NFILES)
+   IF(NFILES GREATER 0)
