## sarg 2.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
 PROJECT(sarg C)
 SET(sarg_VERSION 2)
-SET(sarg_REVISION "3")
+SET(sarg_REVISION "3.1")
 SET(sarg_BUILD "")
-SET(sarg_BUILDDATE "Jun-21-2010")
+SET(sarg_BUILDDATE "Sep-18-2010")
 
 INCLUDE(AddFileDependencies)
 INCLUDE(CheckIncludeFile)
