## sarg 2.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
 PROJECT(sarg C)
 SET(sarg_VERSION 2)
-SET(sarg_REVISION "3.1")
+SET(sarg_REVISION "3.2")
 SET(sarg_BUILD "")
-SET(sarg_BUILDDATE "Sep-18-2010")
+SET(sarg_BUILDDATE "Nov-23-2011")
 
 INCLUDE(AddFileDependencies)
 INCLUDE(CheckIncludeFile)
@@ -12,6 +12,7 @@
 INCLUDE(CheckTypeSize)
 INCLUDE(CheckSymbolExists)
 INCLUDE(CheckCCompilerFlag)
+INCLUDE(CheckStructHasMember)
 
 DEFINE_PROPERTY(GLOBAL PROPERTY enable-htmldir BRIEF_DOCS "--enable-htmldir=htmldir"
                         FULL_DOCS "Select htmldir as the root of your WWW documents")
@@ -37,7 +38,7 @@
 
 SET(SYSCONFDIR "etc/sarg" CACHE PATH "The configuration directory relative to the install directory")
 SET(BINDIR "bin" CACHE PATH "The directory to install the exec relative to the install directory")
-SET(MANDIR "share/man" CACHE PATH "The directory to copy the man page relative to the install directory")
+SET(MANDIR "share/man/man1" CACHE PATH "The directory to copy the man page relative to the install directory")
 SET(LANGDIR "share/sarg/languages" CACHE PATH "The directory to copy the languages files relative to the install directory")
 SET(FONTDIR "share/sarg/fonts" CACHE PATH "The directory to copy the fonts relative to the install directory")
 SET(IMAGEDIR "share/sarg/images" CACHE PATH "The directory to copy the images files relative to the install directory")
@@ -47,13 +48,13 @@
 INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}") #Make it find this config.h before the one in src/include
 INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/include")
 SET(SRC util.c log.c report.c topuser.c email.c sort.c html.c
-       totger.c index.c getconf.c usage.c decomp.c ip2name.c
+       index.c getconf.c usage.c decomp.c ip2name.c
        useragent.c exclude.c convlog.c totday.c repday.c datafile.c
        indexonly.c splitlog.c lastlog.c topsites.c siteuser.c css.c
        smartfilter.c denied.c authfail.c charset.c
-       squidguard_log.c squidguard_report.c auth.c download.c grepday.c
+       redirector.c auth.c download.c grepday.c
        dansguardian_log.c dansguardian_report.c realtime.c btree_cache.c
-       usertab.c userinfo.c longline.c)
+       usertab.c userinfo.c longline.c url.c)
 
 FOREACH(f ${SRC})
    ADD_FILE_DEPENDENCIES(${f} ${CMAKE_BINARY_DIR}/config.h ${CMAKE_SOURCE_DIR}/include/conf.h ${CMAKE_SOURCE_DIR}/include/info.h ${CMAKE_SOURCE_DIR}/include/defs.h)
@@ -95,10 +96,10 @@
 CHECK_INCLUDE_FILE(unistd.h HAVE_UNISTD_H)
 CHECK_INCLUDE_FILE(sys/dirent.h HAVE_SYS_DIRENT_H)
 CHECK_INCLUDE_FILE(dirent.h HAVE_DIRENT_H)
+CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
 CHECK_INCLUDE_FILE(sys/socket.h HAVE_SYS_SOCKET_H)
 CHECK_INCLUDE_FILE(netdb.h HAVE_NETDB_H)
 CHECK_INCLUDE_FILE(arpa/inet.h HAVE_ARPA_INET_H)
-CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
 CHECK_INCLUDE_FILE(netinet/in.h HAVE_NETINET_H)
 CHECK_INCLUDE_FILE(sys/stat.h HAVE_SYS_STAT_H)
 CHECK_INCLUDE_FILE(ctype.h HAVE_CTYPE_H)
@@ -115,6 +116,7 @@
 CHECK_INCLUDE_FILE(libgen.h HAVE_LIBGEN_H)
 CHECK_INCLUDE_FILE(stdbool.h HAVE_STDBOOL_H)
 CHECK_INCLUDE_FILE(getopt.h HAVE_GETOPT_H)
+CHECK_INCLUDE_FILE(fcntl.h HAVE_FCNTL_H)
 
 IF(!HAVE_GETOPT_H)
    MESSAGE(SEND_ERROR "getopt.h is required to compile sarg")
@@ -146,7 +148,10 @@
 CHECK_FUNCTION_EXISTS(symlink HAVE_SYMLINK)
 CHECK_FUNCTION_EXISTS(lstat HAVE_LSTAT)
 CHECK_FUNCTION_EXISTS(getnameinfo HAVE_GETNAMEINFO)
+CHECK_FUNCTION_EXISTS(getaddrinfo HAVE_GETADDRINFO)
 CHECK_FUNCTION_EXISTS(inet_aton HAVE_INET_ATON)
+
+CHECK_STRUCT_HAS_MEMBER("struct sockaddr_storage" ss_len sys/socket.h HAVE_SOCKADDR_SA_LEN)
 
 # Find gd
 CHECK_INCLUDE_FILE(gd.h HAVE_GD_H)
@@ -307,9 +312,3 @@
    SET(FILES)
    IF(HAVE_LOCALE_H)
       LIST(APPEND FILES "locale.h")
-   ENDIF(HAVE_LOCALE_H)
-   IF(HAVE_LIBINTL_H)
-      LIST(APPEND FILES "libintl.h")
-   ENDIF(HAVE_LIBINTL_H)
-   LIST(LENGTH FILES NFILES)
-   IF(NFILES GREATER 0)
