=== debian/changelog ===
sarg (2.3.2-2) unstable; urgency=low

  * debian/rules
    - Fixed wrong auto detection of build system by dh (Closes: #654319)

 -- Luigi Gangitano <luigi@debian.org>  Fri, 06 Jan 2012 01:32:52 +0100

sarg (2.3.2-1) unstable; urgency=low

  * New upstream release
    - Fixes FTBFS with latest GCC (Closes: #626228)

  * debian/{control,rules,install,manpages,source/format,patches/*}
    - Switch to source format 3.0 (quilt)

  * debian/control
    - Bumped Standard-Version to 3.9.2 (no change needed)

 -- Luigi Gangitano <luigi@debian.org>  Mon, 26 Dec 2011 18:21:40 +0100

sarg (2.3.1-2) unstable; urgency=low

  * debian/{patches/03_build-with-gcc44,rules}
    - Removed configure.in patch, replaced with LDFLAG in debian/rules,
      thanks to Andrea Gasparini

 -- Luigi Gangitano <luigi@debian.org>  Sat, 19 Feb 2011 17:48:24 +0100

sarg (2.3.1-1) unstable; urgency=low

  * New upstream release

  * debian/sarg-reports
    - Fix date interval for daily/weekly/monthly (Closes: #592705)

  * debian/preinst
    - Remove old language files (Closes: #606778)
    - Fix moving output files on upgrade

  * debian/patches/03_build-with-gcc44
    - Added libm check to configure.in to comply with gcc-4.4 linker chages

  * debian/control
    - Bumped Standard-Version to 3.9.1 (no change needed)

 -- Luigi Gangitano <luigi@debian.org>  Fri, 18 Feb 2011 19:59:33 +0100

sarg (2.3-1) unstable; urgency=low

  * New upstream release

  * debian/rules
    - Removed references to now non existent language dir

  * debian/control
    - Added build dependency on libldap2-dev
    - Bumped Standard-Version to 3.8.4 (no change needed)

  * debian/sarg.conf
    - Updated to match new upstream config file

  * debian/preinst
    - Fix moving old data files

 -- Luigi Gangitano <luigi@debian.org>  Sat, 26 Jun 2010 00:49:09 +0200

sarg (2.2.7.1-2) unstable; urgency=low

  * debian/{preinst,postinst}
    - Move configuration files preserving user changes (Closes: #566402)
    - Do not move duplicate fonts
    - Remove fonts marked as configuration files

 -- Luigi Gangitano <luigi@debian.org>  Sun, 28 Mar 2010 01:33:48 +0100

sarg (2.2.7.1-1) unstable; urgency=low

  * New upstream release

  * debian/sarg.conf
    - Updated default configuration file to match upstream changes.
    - Removed invalid config directive (Closes: #568009)

  * debian/README.source
    - Added simple dpatch-referring REAMDE.source

  * debian/{rules,control}
    - Remove duplicate font files and depend on ttf-dejavu-core | ttf-freefont
      (Closes: #567329)

 -- Luigi Gangitano <luigi@debian.org>  Tue, 16 Feb 2010 11:07:18 +0100

sarg (2.2.7-1) UNRELEASED; urgency=low

  * New upstream release
    - Fixes sarg.hosts exclusion for subdomains (Closes: #408577)

  * debian/patches/01_makefile-install-path
    - Removed patch integrated upstream

  * debian/rules
    - Use --enable-sargphp instead of --enable-htmldir

 -- Luigi Gangitano <luigi@debian.org>  Mon, 08 Feb 2010 08:00:10 +0100

sarg (2.2.6-1) unstable; urgency=low

  * New upstream release
    - Fixes issues in getword loop detection (Closes: #522284)
    - Removed patches integrated upstream
    - Fixes usertab parsing for IPv6 address (Closes: #504749)
    - Fixes typo in dansguardian_log.c (Closes: #540438)
    - Fixes error parsing squidGuard logs (Closes: #486895)

  * debian/sarg-reports.conf
    - Fixed typo (Closes: #517356)

  * debian/control
    - Added Build-Dep options on libgd2-xpm-dev (Closes: #540121)
    - Added Dependency on ${misc:Depends}
    - Added dependency on dpatch
    - Bumped Standard-Version to 3.8.3

  * debian/compat
    - Upgraded debhelper compatibility to level 6

  * debian/rules
    - Removed unnecessary upgrade of autoconf files
    - Added dpatch rules
    - Fixed configuration options and paths

  * debian/patches/01_makefile-install-path
    - Fixed build-time installation paths

  * debian/patches/02_config-file-references
    - Fixed references to configuration files

  * debian/squid.conf
    - Sinced with upstream changes

  * debian/{postrm,preinst,sarg.conf,sarg-reports,rules,dirs,sarg-reports.conf}
    - Moved configuration files to /etc/sarg and data directory to /var/lib/sarg
      (Closes: #553554, #502273)

 -- Luigi Gangitano <luigi@debian.org>  Mon, 11 Jan 2010 15:07:10 +0100

sarg (2.2.5-2) unstable; urgency=low

  * debian/watch
    - Use SF redirector and make lintian happy

  * debian/{rules,compat}
    - Move DH_COMPAT to debian/compat and make lintian happy

  * debian/rules
    - Change make clean invocation and make lintian happier
    - Added support for DEB_BUILD_OPTIONS
    - Move documentation files from sarg-php to doc directory
    - Remove hidden file from /etc/squid/languages

  * debian/control
    - Removed dependency on bash, now essential
    - Bumped Standard-Version to 3.8.0

  * debian/postinst
    - Make postint fail on error

  * debian/copyright
    - Added copyright notice
    - Updated maintainer reference

  * debian/sarg-reports.1
    - Added man page, thanks to Juan Angulo Moreno (Closes: #481889)

  * debian/patches/show_read_statistics.patch
    - Added patch from Vladimir Lettiev fixing segfault with
      show_read_statistics set to no. (Closes: #444845, # 370811)

  * debian/patches/totger_patches.patch
    - Added patch from Thomas Bliesener fixing several buffer overflows
      (Closes: #470791)

  * debian/patches/opensuse_1_getword_boundary_limit.patch
    - Added patch from OpenSUSE to avoid segfaults in getword() calls

  * debian/patches/opensuse_2_enlarge_report_buffers.patch
    - Added patch from OpenSUSE to avoid overflow in report buffers

  * debian/patches/opensuse_3_too_small_font_buffer.patch
    - Added patch from OpenSUSE to avoid overflow in font buffer

  * debian/patches/opensuse_4_enlarge_log_buffer.patch
    - Added patch from OpenSUSE to avoid overflow in log buffer

  * debian/patches/opensuse_5_limit_sprintf.patch

