=== debian/control ===
Source: sarg
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, libgd2-noxpm-dev | libgd2-xpm-dev, libldap2-dev
Section: web
Priority: optional
Maintainer: Luigi Gangitano <luigi@debian.org>
Standards-Version: 3.9.2

Package: sarg
Architecture: any
Replaces: sqmgrlog
Depends: ${shlibs:Depends}, ${misc:Depends}, ttf-dejavu-core | ttf-freefont
Suggests: squid, httpd | apache2, squidguard, libapache2-mod-php5
Conflicts: sqmgrlog
Description: squid analysis report generator
 Sarg is a Squid Analysis Report Generator that allow you to view "where" 
 your users are going to on the Internet. Sarg generate reports in html, 
 with many fields, like: users, IP Addresses, bytes, sites and times.
