## sarg 2.3.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,9 @@
 CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
 PROJECT(sarg C)
 SET(sarg_VERSION 2)
-SET(sarg_REVISION "3.2")
+SET(sarg_REVISION "3.6")
 SET(sarg_BUILD "")
-SET(sarg_BUILDDATE "Nov-23-2011")
-
+SET(sarg_BUILDDATE "Apr-21-2013")
 INCLUDE(AddFileDependencies)
 INCLUDE(CheckIncludeFile)
 INCLUDE(CheckLibraryExists)
@@ -32,14 +31,12 @@
 ENDMACRO(SET_ABS_SOURCE VAR DOC)
 
 SET_ABS_SOURCE(SYSCONFDIR "The full path of the configuration directory to be compiled in the program")
-SET_ABS_SOURCE(LANGDIR "The full path of the language directory to be compiled in the program")
 SET_ABS_SOURCE(FONTDIR "The full path of the fonts directory to be compiled in the program")
 SET_ABS_SOURCE(IMAGEDIR "The full path of the images directory to be compiled in the program")
 
 SET(SYSCONFDIR "etc/sarg" CACHE PATH "The configuration directory relative to the install directory")
 SET(BINDIR "bin" CACHE PATH "The directory to install the exec relative to the install directory")
 SET(MANDIR "share/man/man1" CACHE PATH "The directory to copy the man page relative to the install directory")
-SET(LANGDIR "share/sarg/languages" CACHE PATH "The directory to copy the languages files relative to the install directory")
 SET(FONTDIR "share/sarg/fonts" CACHE PATH "The directory to copy the fonts relative to the install directory")
 SET(IMAGEDIR "share/sarg/images" CACHE PATH "The directory to copy the images files relative to the install directory")
 SET(SARGPHPDIR "share/sarg/sarg-php" CACHE PATH "The directory to copy sarg-php relative to the install directory")
@@ -48,11 +45,11 @@
 INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}") #Make it find this config.h before the one in src/include
 INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/include")
 SET(SRC util.c log.c report.c topuser.c email.c sort.c html.c
-       index.c getconf.c usage.c decomp.c ip2name.c
+       index.c getconf.c usage.c decomp.c ip2name.c ip2name_dns.c
        useragent.c exclude.c convlog.c totday.c repday.c datafile.c
        indexonly.c splitlog.c lastlog.c topsites.c siteuser.c css.c
-       smartfilter.c denied.c authfail.c charset.c
-       redirector.c auth.c download.c grepday.c
+       smartfilter.c denied.c authfail.c charset.c dichotomic.c
+       redirector.c auth.c download.c grepday.c ip2name_exec.c
        dansguardian_log.c dansguardian_report.c realtime.c btree_cache.c
        usertab.c userinfo.c longline.c url.c)
 
@@ -230,6 +227,17 @@
       SET(HAVE_LDAP CACHE BOOL DOC "True if must use LDAP")
    ENDIF(LDAP_LIBRARY)
 ENDIF(HAVE_LDAP_H)
+
+# Find pcre
+CHECK_INCLUDE_FILE(pcre.h HAVE_PCRE_H)
+IF(HAVE_PCRE_H)
+   FIND_LIBRARY(PCRE_LIBRARY NAMES pcre DOC "The pcre library")
+   IF(PCRE_LIBRARY)
+      TARGET_LINK_LIBRARIES(sarg ${PCRE_LIBRARY})
+      SET(HAVE_PCRE PCRE_LIBRARY CACHE PATH DOC "True if pcre was found")
+      SET(HAVE_PCRE CACHE BOOL DOC "True if must use pcre")
+   ENDIF(PCRE_LIBRARY)
+ENDIF(HAVE_PCRE_H)
 
 # Support for large files
 OPTION(ENABLE_LARGEFILE "Enable the usage of large files" ON)
@@ -303,12 +311,3 @@
    # MingW provide mkstemps in libiberty but doesn't declare it in any header file
    FIND_LIBRARY(IBERTY_LIB NAMES iberty DOC "The library of mingw containing mkstemps")
    IF(IBERTY_LIB)
-      TARGET_LINK_LIBRARIES(sarg iberty)
-   ENDIF(IBERTY_LIB)
-ENDIF(NOT HAVE_MKSTEMP)
-
-# Gettext and friends
-IF(NOT HAVE_LC_MESSAGES)
-   SET(FILES)
-   IF(HAVE_LOCALE_H)
-      LIST(APPEND FILES "locale.h")
