=== debian/changelog ===
sarg (2.3.6-1build1) saucy; urgency=low

  * Rebuild for libgd3.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 20 May 2013 00:32:41 +0100

sarg (2.3.6-1) unstable; urgency=low

  * New upstream release

  * debian/{compat,control,rules}
    - Move the debhelper 9 compatibility and enable hardening flags

  * debian/control
    - Added dependency on dpkg-dev (>= 1.16.1~)
    - Bumped Standard-Version to 3.9.4 (no change needed)

  * debian/rules
    - Add executable bit to /etc/sarg/user_limit_block

  * debian/sarg-reports.1
    - Fixed configuration file reference (Closes: #674036)

 -- Luigi Gangitano <luigi@debian.org>  Mon, 06 May 2013 16:39:45 +0200
