=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: sarg
-Build-Depends: debhelper (>= 7.0.50~), autotools-dev, libgd2-noxpm-dev | libgd2-xpm-dev, libldap2-dev
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), autotools-dev, libgd2-noxpm-dev | libgd2-xpm-dev, libldap2-dev
 Section: web
 Priority: optional
 Maintainer: Luigi Gangitano <luigi@debian.org>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 
 Package: sarg
 Architecture: any
