=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,10 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 #export DH_OPTIONS=-v
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 INSTALL = install
 INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
@@ -44,6 +48,7 @@
 	mv debian/sarg/usr/share/sarg/sarg-php/LANGUAGES debian/sarg/usr/share/doc/sarg/LANGUAGES.sarg.php
 	chmod 644 debian/sarg/etc/sarg/sarg.*
 	chmod 755 debian/sarg/etc/sarg
+	chmod 755 debian/sarg/etc/sarg/user_limit_block
 	chmod 755 debian/sarg/usr/sbin/sarg-reports
 	chmod 755 debian/sarg/etc/cron.daily/sarg
 	chmod 755 debian/sarg/etc/cron.weekly/sarg
