=== debian/watch ===
version=2
http://sf.net/sarg/sarg-(.*)\.tar\.gz debian uupdate
